#!/bin/bash
#/**
#       createtimage
#@brief  Crea o redimensiona el archivo de la imagen.
#@param 1 imagen
#@param 2 extension [ img|diff ]
#@param 3 tamaño de la imagen en kb.
#@return  
#@exception OG_ERR_FORMAT     # 1 formato incorrecto.
#@exception OG_ERR_DONTSYNC_IMAGE  #71 Imagen no sincronizable (es monolitica)
#@version 1.0 - Montar imagen sincronizable
#@author  Irina Gomez
#@date   2013-05-23
#*/ ##
BASEDIR=/opt/opengnsys
REPODIR="$BASEDIR/images"
REPOLOG=$BASEDIR/log/ogAdmRepo.log
source $BASEDIR/client/etc/lang.$LANG.conf

PROG="$(basename $0)"
# Si se solicita, mostrar ayuda.
if [ "$*" == "help" ]; then
    echo -e " $PROG: $MSG_HELP_ogCreateFileImage \n" \
            "$MSG_FORMAT: $PROG image [ img|diff ] size_kb \n" \
            "base -> $PROG Windows7 img 3900000 \n" \
	    "diff -> $PROG Ubuntu12 diff 450000"
   exit 0
fi

[ $# -lt 3 ] && echo -e "$PROG: Error: $MSG_ERR_FORMAT \n     $MSG_FORMAT: $PROG image [ img | diff ]  size_Kb "  && exit 1

if [ "$USER" != "root" ]; then
        echo "$PROG: Error: solo ejecutable por root" >&2
        exit 1
fi

IMGEXT="$2"

# Si existe imagen, Comprobamos que no esta bloqueada y que es sincronizable
IMGFILE="$REPODIR/$1.$IMGEXT"
if [ -f $IMGFILE ]; then
   [ -f $IMGFILE.lock ] && echo "$PROG: Error: $MSG_ERR_LOCKED $1 $IMGEXT" && exit 4
	
   if ! file $IMGFILE | grep " BTRFS Filesystem" >/dev/null ; then
	echo "$PROG: Error: $MSG_ERR_DONTSYNC_IMAGE $1 $2"
	exit 71
   fi
fi

touch $IMGFILE.lock

# El tamaño minimo de la imagen es 300000 para poder formatear en fs btrfs.
SIZEREQUIRED=$3
[ $SIZEREQUIRED -lt 300000 ] && SIZEREQUIRED=300000

echo  CREATE_IMAGE "$1" $IMGEXT $SIZEREQUIRED
echo -ne CREATE_IMAGE "$1" $IMGEXT $SIZEREQUIRED| /opt/opengnsys/sbin/ogAdmRepoAux
echo "Los resultado se registran en $REPOLOG. "

rm $IMGFILE.lock
